<?php
/*
	*功能：付完款后跳转的页面（返回页）
	*版本：3.0
	*日期：2010-05-21
	'说明：
	'以下代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写,并非一定要使用该代码。
	'该代码仅供学习和研究支付宝接口使用，只是提供一个参考。
	
*/
///////////页面功能说明///////////////
//该页面可在本机电脑测试
//该页面称作“返回页”，是由支付宝服务器同步调用，可当作是支付完成后的提示信息页，如“您的某某某订单，多少金额已支付成功”。
//可放入HTML等美化页面的代码和订单交易完成后的数据库更新程序代码
//该页面可以使用PHP开发工具调试，也可以使用写文本函数log_result进行调试，该函数已被默认关闭，见alipay_notify.php中的函数return_verify
//TRADE_FINISHED(表示交易已经成功结束，为普通即时到帐的交易状态成功标识);
//TRADE_SUCCESS(表示交易已经成功结束，为高级即时到帐的交易状态成功标识);
///////////////////////////////////
include "inc.php";
require_once SYS_ROOT.'/cls_tab/tab.pay.type.php';
$obj_tab_type=new cls_tab_pay_type;
$base_dir=$obj_tab_type->api_dir;

$arr_config=$obj_tab_type->get_type_fields("alipay");
require_once ($base_dir."/alipay/alipay_notify.php");

//构造通知函数信息
$alipay = new alipay_notify($arr_config["partner"],$arr_config["key"],"MD5",strtoupper(DB_CHARSET),"http");
//计算得出通知验证结果
$verify_result = $alipay->return_verify();

if($verify_result) {

    //验证成功
    //获取支付宝的通知返回参数
    $dingdan           = $_GET['out_trade_no'];    //获取订单号
    $total_fee         = $_GET['total_fee'];	    //获取总价格
    $sOld_trade_status = "0";		    //获取商户数据库中查询得到该笔交易当前的交易状态

    /*假设：
	sOld_trade_status="0";表示订单未处理；
	sOld_trade_status="1";表示交易成功（TRADE_FINISHED/TRADE_SUCCESS）；
    */

    if($_GET['trade_status'] == 'TRADE_FINISHED' || $_GET['trade_status'] == 'TRADE_SUCCESS') {

        //放入订单交易完成后的数据库更新程序代码，请务必保证echo出来的信息只有success
        //为了保证不被重复调用，或重复执行数据库更新程序，请判断该笔交易状态是否是订单未处理状态
        if ($sOld_trade_status < 1) {
            //根据订单号更新订单，把订单处理成交易成功
			$arr_pay_return=array(
				"number"=>$dingdan,
				"pay_money"=>$total_fee
			);
			$obj_tab_type->on_pay_ok($arr_pay_return);
        }
		$show = $obj_tab_type->pay_ok_url;
		go_url($show);
    }
    else {
		echo "<br/>" . "支付失败" . "<br/>";
		set_log("alipay","trade_status=".$_GET['trade_status'],array(),true);
    }
}
else {
    //验证失败
    //如要调试，请看alipay_notify.php页面的return_verify函数，比对sign和mysign的值是否相等，或者检查$veryfy_result有没有返回true
	echo "<br/>" . "认证签名失败" . "<br/>";
	set_log("alipay","fail",array(),true);
}
?>